c OCCAM2DMT 1.0: Steven Constable IGPP/SIO La Jolla CA 92093-0225
c Commons Revision 1.04, 13 Jan 93
c revision to allow for complex impedances - cdh - February 18, 1994
c   (added PW's BLKx.INCs to reduce number of include files needed)
c
c get required dimensions from include files
      include 'occamdim.inc'
      include 'mt2Ddim.inc'
c	
c-----------------------------------------------------------------------
c /rgrid/ contains information about the regularization bricks in terms
c   of PWs FE mesh, as well as info about the penalty matrix
      integer nlay, nrcol, nrfix, nbrick, nexep
      integer ijexep 
      real thick, width, y, expen, prewt
      common /rgrid/ nlay, nrcol(nl), thick(npp), width(npp), nrfix, 
     *   y(npp+36),nbrick,nexep,ijexep(maxexp,2),expen(maxexp), 
     *   prewt(npp)
c   nlay = number of layers in regularization grid
c   nrcol() = number of regularization bricks in each row
c   thick() = vertical thickness of each reg. brick 
c   width() = width of each reg. brick in metres
c   nrfix = number of fixed resistivities in mesh (an offset for the y() vector)
c   y() = lookup table of resistivities, passed into pw2di
c   nbrick = number of free resistivity bricks (my copy of nprm)
c   nexep = number of exceptions in penalty matrix
c   ijexep() = brick parameter indices of exeption pairs 
c   expen() = penalties for exeptions
c   prewt() = penalties for model prejudice
c
c-----------------------------------------------------------------------
c /datinfo/ contains station information and other stuff pertinent to
c   the data array
	integer nrc, nfre, nrl, ndata
	real sitloc, boffs, frek
	common /datinfo/ nrc, nrl(nr), ndata, nfre, boffs,  
     *  frek(nf), sitloc(nr)
c   nrc = number of receiver sites
c   sitloc() = site locations by distance in meters from origin
c   nrl() = site locations by FE mesh node number
c   boffs = binding offset (location of right edge of the left terminating layers of
c           regularization mesh in the same coords as sitloc())
c   nfre = number of frequencies
c   frek() = frequencies (Hz)
c   ndata = number of actual MT data (c.f. static shift constraints)
c
c-----------------------------------------------------------------------
c /sitcom/ contains the site names.  These are not actually used by
c   occam but are for the user's convenience.
	character*30 sitnam
	common /sitcom/ sitnam(nr)
c   sitnam() = site names (alphanumeric)
c-----------------------------------------------------------------------
c /statics/ contains info on the static shifts, both fixed and free.
c   Size of the arrays should not be any larger than (2 modes) times
c   maximum number of sites
	integer isx1, isx3, iscon, nfss, isfx, nsb
	real shift
	common /statics/ nsb, iscon, nfss, isx1(2*nr), isx3(2*nr), 
     *  isfx(2*nr), shift(2*nr)
c   nsb = number of blocks of static shift data (one per site/mode)
c   iscon = type of static shift data constraint:
c     0 = no constraint
c     1 = TE and TM modes sum to sum of log(initial values) together
c     2 = TE and TM modes sum to sum of log(initial values) separately
c   nfss = number of free (invertible) static shifts
c   isx1() = index of data stations for each shift block
c   isx3() = index of data type for each shift block (should be only
c     1 = TE resisitivity or 5 = TM resistivity)
c   isfx() = lookup table for invertible shifts. 0 = fixed shift,
c     n = invertible shift is nth parameter (PM(n))
c   shift() = log10(static shift corrections) to be applied to the data
c-----------------------------------------------------------------------
c /decomp/ contains info on the decomposition parameters, both fixed and free.
c   Size of the arrays should not be any larger than (4 modes) times
c   maximum number of sites
	integer idx1, idx3, idcon, nfdp, idfx, ndcp, nstat, itfx
	real dcomp, theta
	common /decomp/ nstat, ndcp, idcon, nfdp, idx1(nr,4), idx3(nr,4), 
     *  idfx(nr,4), dcomp(nr,4), theta, itfx
c   ndcp = number of blocks of decomposion parameters (one per site/mode)
c   idcon = type of decomposition parameter constraint:
c     0 = no constraint
c     1 = TE and TM modes multiply to product of (initial values) together
c     2 = TE and TM modes multiply to product of (initial values) separately
c   nfdp = number of free (invertible) decomposition parameters
c   idx1() = index of data stations for each shift block
c   idx3() = intex of data type for each shift block (should be only
c     9 or 10 or = TE or 11 or 12 = TM)
c   idfx() = lookup table for invertible shifts. 0 = fixed,
c     n = invertible shift is nth parameter (PM(n))
c   dcomp() = decomposition parameter to be applied to the data
c-----------------------------------------------------------------------
