C OCCAM 2.0: Steven Constable IGPP/SIO La Jolla CA 92093-0225
c Commons Revision 2.00, 13 May 1992
c-----------------------------------------------------------------------
c /data/ contains the constraint data for the inversion:
	real d, sd, dp
	integer nd, ndp
	common /data/ nd, d(ndd), sd(ndd), dp(ndd,3), ndp
c   nd = number of data
c   d() = data 
c   cd() = complex impedances
c   sd() = data errors (one standard error)
c   dp() = array of up to 4 parameters associated with each datum (freq., range etc)
c   ndp = number of data parameters used 
c
c-----------------------------------------------------------------------
c /model/ contains the current model parameters for this iteration and its response
	real pm, dm
	integer np
	common /model/ np, pm(npp), dm(ndd)
c   np = number of free model parameters
c   pm() = array of model parameters
c   dm() = array to carry model response (data domain) around
c
c-----------------------------------------------------------------------
c /result/ contains stuff to be carried into critical subroutines 
	real ptp, wjtwj, wjtwd, pwk1, pwk2, pwk3, frac
	integer idebug, nfor, iout
	common /result/ ptp(npp,npp), wjtwj(npp,npp), wjtwd(npp),
     *       pwk1(npp),pwk2(npp),pwk3(npp),frac,nfor,iout,idebug
c
c   ptp() = product of penalty matrix with its transpose
c   wjtwj() = product of weighted jacobian matrix with its transpose
c   wjtwd() = product of weighted jacobian matrix with weighted translated data
c   pwk1,2,3() = vectors to carry around working copies of models
c   frac = current reduction in step size
c   nfor = tally for total number of forward caluculations
c   iout = unit number of output (usually LOGFIL)
c   idebug = current debug level
c-----------------------------------------------------------------------
c /bound/ contains variables associated with solving for boundary
c depths and large resistivity blocks
      integer kblock(nbl),ijind(nl2,mcol2),iblock(nbl,npp),
     +       irindx(nl2,mcol2),idepth(nbl-1,mcol2),nbig,npinv,llay,lcol,
     +       iseadp(mcol2)
      real depth(nl2+1), pminv(nbl+(nbl-1)*mcol2),seadep(mcol2),
     +       pmbig(10)
      common /bound/depth,pminv,kblock,ijind,iblock,idepth,irindx,
     +        nbig,npinv,llay,lcol,iseadp,seadep,pmbig

c irindx() : layer/column to parameter pointers.  0 if fixed block
c pminv    : inversion parameters
c npinv    : number of inversion parameters
c nbig     : number of large resistivity blocks
c iblock   : index indicating which small blocks belong to each large unit
c kblock   : number of blocks within each large unit
c ijind    : index indicating which large unit each small block belongs to
c idepth   : index for depth to bottom of unit
c depth	   : depths to top and bottom of blocks
c llay,lcol: number of layers and columns

