c altering code to solve for model with limited number of resistive blocks
c with movable boundaries between the blocks.
c I solve for the log(res'ty) of the block as well as boundary locations
c penalty is applied to variations in boundary depth
c   Jan22, 2002 - model prejudice disallowed 
c               - exceptions to penalty matrix also disallowed
c   Feb, 2002 - Occam inversion for boundary depths and log10(resistivity)
c               of large units (<=10)
c               -model prejudice disallowed
c               -no fixed blocks allowed (aside from the sea)
c               -all rows must have the same number of columns
C-----------------------------------------------------------------------
      subroutine itrin (itform,descr,modfil,datfil,maxitr,tolreq,
     *    iruf,nit,pmu,rlast,tobt,ifftol,iof2)      
C-----------------------------------------------------------------------
c
C OCCAM 2.0: Steven Constable IGPP/SIO La Jolla CA 92093-0225
c Subroutine Revision 2.01, 13 Jan 1993
C
c reads a STARTUP or ITER file for OCCAM
c
c includes:
      include 'imp.inc'
      include 'occamdim.inc'
c   uses npp
      include 'occam.inc'
c   uses np, pm(), idebug
c arguments:
      integer maxitr, iruf, nit, ifftol,iof2
      real tolreq, pmu, rlast, tobt
      character*50 modfil, datfil, itform, descr
c local variables
      integer i, idcode
c   i = loop index
c   idcode = function to perform the equivalent of a free-format internal
c            read for an integer
      real rdcode
c   rdcode = function to perform the equivalent of a free-format internal
c            read for a real
      character*80 string
C
C-----------------------------------------------------------------------
      read(unit=iof2,fmt='(18x,a)', end=198, err=199) itform
      read(unit=iof2,fmt='(18x,a)', end=198, err=199) descr
      read(unit=iof2,fmt='(18x,a)', end=198, err=199) modfil
      read(unit=iof2,fmt='(18x,a)', end=198, err=199) datfil
      read(unit=iof2,fmt='(18x,a)', end=198, err=199) string
c
      read(unit=iof2,fmt='(18x,a)', end=198, err=199) string
      maxitr = idcode(string,iof2)
      read(unit=iof2,fmt='(18x,a)', end=198, err=199) string
      tolreq = rdcode(string,iof2)
      read(unit=iof2,fmt='(18x,a)', end=198, err=199) string
      iruf = idcode(string,iof2)
      read(unit=iof2,fmt='(18x,a)', end=198, err=199) string
      idebug = idcode(string,iof2)
      read(unit=iof2,fmt='(18x,a)', end=198, err=199) string
      nit = idcode(string,iof2)
      read(unit=iof2,fmt='(18x,a)', end=198, err=199) string
      pmu = rdcode(string,iof2)
      read(unit=iof2,fmt='(18x,a)', end=198, err=199) string
      rlast = rdcode(string,iof2)
      read(unit=iof2,fmt='(18x,a)', end=198, err=199) string
      tobt = rdcode(string,iof2)
      read(unit=iof2,fmt='(18x,a)', end=198, err=199) string
      ifftol = idcode(string,iof2)
      read(unit=iof2,fmt='(18x,a)', end=198, err=199) string
      np = idcode(string,iof2)
      if (np .gt. npp) call filerr (' Too many parameters', iof2)
      read (unit=iof2,fmt= *, end=198, err=199) (pm(i), i=1,np)
c
      read(unit=iof2,fmt= *, end=198, err=199) nbig
      write(*,*) 'nbig=',nbig
      if (nbig .gt. 10) then
         print *, 'FATAL ERROR: must be .le. 10 large blocks'
         stop
      endif
      read(unit=iof2,fmt= *,end=198, err=199) (pminv(i),i=1,nbig)
      write(*,*) 'resistivities', (pminv(i),i=1,nbig)
c
      return
c
198      call filerr (' Startup file ended prematurely', iof2)
199      call filerr (' Error reading startup file', iof2)
      end
C
C-----------------------------------------------------------------------
      subroutine inputd(datfil)
c-----------------------------------------------------------------------
c
c OCCAM2DMT 1.0: Steven Constable IGPP/SIO La Jolla CA 92093-0225
c Subroutine Revision 1.02, 13 Jan 1993
c revision to allow for impedance data - cdh -February 23, 1994
c revision to allow for Zrot value of input data - cdh -March 29, 1999
c
c inputd opens the data file datfil and reads in the data array
c
c on input:
c   datfil = data file name 
c
c on output:
c   lots of stuff in common blocks (see include files)
c
c calls:  
c   filerr
c
c includes:
      include 'imp.inc'
      include 'mt2D.inc'
      include 'blki.inc'
c uses nrc, sitnam(), sitloc(), nfre, frek()
c uses idx
      include 'occam.inc'
c uses nd, d(), sd(), dp(), ndp
c arguments:
      character*(*) datfil
c local variables
      logical iffte, ifftm, iffvf
c   flags to indicate which modes are required
      integer lerr, i, j
c   error flag, loop index and handy integer
      character*80  string
c   string buffer
      integer idcode
c   idcode= function to perform the equivalent of a free-format internal
c            read for an integer
c
c parameters:
      integer iof 
      parameter (iof = 15)
c   iof = io unit number for file operations
c
c-----------------------------------------------------------------------
c there are 3 data parameters in 2D MT (site, freq, data type)
      ndp = 3
c open data file 
      open (iof, file=datfil, status='old', iostat=lerr)
      if (lerr .ne. 0) then
        write(*,*) ' Error opening data file'
        stop
      end if
c read stuff
      read(iof,'(18x,a)', end=198, err=199) string
c     if (string(1:16) .ne. 'OCCAM2MTDATA_1.0') call filerr(
c    *  ' Data file not supported',iof)
      read(iof,'(18x,a)', end=198, err=199) string
      read(iof,'(18x,a)', end=198, err=199) string
      nrc = idcode(string, iof)
      if (nrc .gt. nr)    call filerr (' Too many sites', iof)
      do 5 i = 1, nrc
5        read(iof,'(a)', end=198, err=199) sitnam(i)
      read(iof,'(a)', end=198, err=199) string
      read(iof,*, end=198, err=199) (sitloc(i), i=1,nrc)
      read(iof,'(18x,a)', end=198, err=199) string
      nfre = idcode(string, iof)
      if (nfre .gt. nf)    call filerr (' Too many frequencies', iof)
      read(iof,*, end=198, err=199) (frek(i), i=1,nfre)
      read(iof,'(18x,a)', end=198, err=199) string
      ndata = idcode(string, iof)
      if (ndata .gt. ndd)    call filerr (' Too many data', iof)
      read(iof,'(a)', end=198, err=199) string
      read(iof,*, end=198, err=199) (dp(i,1),dp(i,2),dp(i,3),
     *  d(i), sd(i), i=1,ndata)
c      
c set idx, the mode definition for PW2DI
      iffte = .false.
      ifftm = .false.
      iffvf = .false.
      do 20 i = 1, ndata
        j = int(dp(i,3)+0.01)
        if ((j.lt.1) .or. (j.gt.14)) then
          write(*,*) ' Invalid data type: ', j
          stop
        end if
        if (j .eq. 1 .or. j .eq. 2) iffte = .true.
        if (j .eq. 3 .or. j .eq. 4) iffvf = .true.
        if (j .eq. 5 .or. j .eq. 6) ifftm = .true.
        if (j .eq. 9 .or. j .eq. 10) iffte = .true.
        if (j .eq. 11 .or. j .eq. 12) ifftm = .true.
        if (j .eq. 7 .or. j .eq. 8) then
          iffte = .true.
          ifftm = .true.
        end if
        if (j .eq. 13 .or. j .eq. 14) then
          iffte = .true.
          ifftm = .true.
        end if
20      continue
c consider vertical field to be TE+TM calculation
      if ((iffte .and. ifftm) .or. iffvf) then
        idx = 1
      else if (iffte) then
        idx = 2
      else if (ifftm) then
        idx = 3
      end if
c      
      if (idebug .ge. 1) then
        write(*,*) ndata, ' data read'
      end if
c      
c initially set nd for occam as number of MT data
      nd = ndata
c      
      return
c
198      call filerr (' Data file ended prematurely', iof)
199      call filerr (' Error reading data file', iof)
c
      end
c     
c-----------------------------------------------------------------------
      subroutine inputm(modfil)
c----------------------------------------------------------------------
c
c OCCAM2DMT 1.0: Steven Constable IGPP/SIO La Jolla CA 92093-0225
c Subroutine Revision 1.04, 14 Jan 1993
c revised to handle decompositions - CdG
c
c inputm() opens and reads the model file modfil, opens and reads the 
c mesh and static shift files pointed at by modfil, and sets up the 
c environments needed by OCCAM and PW2DI.
c
c Note: inputm() assumes that inputd() has already been called
c
c on input:
c   modfil = (character) model file name 
c on output:
c   incredible amounts of stuff in common blocks (see include files)
c calls:
c   filerr
c
      include 'imp.inc'
      include 'mt2D.inc'
      include 'blkd.inc'
      include 'blke.inc'
      include 'blki.inc'
c uses nlay, nrcol(), thick(), width(), nrfix, y()
c uses sitloc, boffs, nrc, nrl()
c uses dly(), dlz(), yy()
c uses laprm(), nprm
c uses npt()
      include 'occam.inc'
c uses np
c
c arguments:
      character*(*) modfil
c      
c local variables:
      integer irz(nl), iry(nl,mcol), lerr, i, l, j
      integer  nsites, lidx, lfre, nexec
      integer ii, jj, inz1, inz2, iny1, iny2
      integer iconb(ipy)
c   irz() = no of vert. FEs in each row
c   iry() = no of horiz FEs in each col for each row
c   irindx() = layer/column to parameter pointers.  0 if fixed block
c   lerr = iostat from file operations
c   i,l,j = loop counters
c   nsites = no of sites read from file.  Ignored after input by OCCAM
c   lidx = type of modelling; should be 0 for OCCAM
c   lfre = number of frequencies read from file. Ignored by OCCAM
c   nexec = type of action required; reset by formod and fordiv
c   ii, jj = index counters for regularization bricks
c   inz1, inz2 = top and  bottom edges of bricks defined by FE mesh
c   iny1, iny2 = left and right edges     ..    ditto          ..
c   iconb() = flag to indicate nodes on conductivity boundaries
      real dummy, tesum, tmsum, sserr, xymult, yxmult, dperr 
c   dummy = dummy variable to read frequencies into
c   tesum = sum of logs of TE free static shifts 
c   tmsum = sum of logs of TM free static shifts 
c   sserr = error term to use in conjuction with static shift constraint
      character*1 apt(ipz,4,ipy)
c   apt() = character array to store 4 resistivity codes for each element
      character*50 mshfil, mshtyp, string, ssfile, prfile, dpfile
c   mshfil = mesh file name
c   mshtyp = mesh type
c   string = string buffer for free format reads
c   ssfile = static shift file name
c   dpfile = decomposition parameter file name
c   prfile = file containing model prejudice and weights
c
      logical iffree
c   iffree = flag to indicate free element in regularization brick
      integer idcode
c   idcode = function to perform the equivalent of a free-format internal
c            read for an integer
      real rdcode
c   rdcode = function to perform the equivalent of a free-format internal
c            read for a real
c next bit deals with moving boundaries
c 
c	pminv    : inversion parameters
c       npinv    : number of inversion parameters
c	nbig     : number of large resistivity blocks
c       iblock   : index indicating which small blocks belong to each large unit
c       kblock   : number of blocks within each large unit
c       ijind    : index indicating which large unit each small block belongs to
c	idepth   : index for depth to bottom of unit
c
c parameters:
      integer iof 
      parameter (iof = 15)
c   iof = io unit number for file operations
c
c-----------------------------------------------------------------------      
cccccccccccccccccccc model file reading cccccccccccccccccccccccccccccccc
c
      open (iof, file=modfil, status='old', iostat=lerr)
      if (lerr .ne. 0) then
        write(*,*) ' Error opening model file'
        stop
      end if
c read character descriptors      
      read (iof,'(18x,a)', end=198, err=199) string
      if (string(1:15) .ne. 'OCCAM2MTMOD_1.0') call filerr(
     *  ' Model file not supported',iof)
      read (iof,'(18x,a)', end=198, err=199) string
      read (iof,'(18x,a)', end=198, err=199) string
      read (iof,'(18x,a)', end=198, err=199) mshfil
      read (iof,'(18x,a)', end=198, err=199) mshtyp
      read (iof,'(18x,a)', end=198, err=199) ssfile
      read (iof,'(18x,a)', end=198, err=199) dpfile
      read (iof,'(18x,a)', end=198, err=199) prfile
c read in the binding offset and number of layers
      read (iof,'(18x,a)', end=198, err=199) string
      boffs = rdcode(string, iof)
      read (iof,'(18x,a)', end=198, err=199) string
      nlay = idcode(string, iof)
      if (nlay .gt. nl) call filerr(' NLAY exceeds dimensions', iof)
c read in regularization mesh description
      do 20 i = 1,nlay
        read (iof,*, end=198, err=199) irz(i),nrcol(i)
        if (i .gt. 1 .and. nrcol(i) .ne. nrcol(i-1)) then
           print *, 'FATAL ERROR: each row must have same # columns'
           stop
        endif
        if (nrcol(i) .gt. mcol) 
     *     call filerr (' Too many columns in reg. mesh', iof)
20        read (iof,*, end=198, err=199) (iry(i,j), j=1,nrcol(i))
c read in exceptions to penalty matrix
      read (iof,'(18x,a)', end=198, err=199) string
      nexep = idcode(string, iof)
      if (nexep .gt. 0) then
        print *, 'no exceptions allowed to penalty matrix, reset to 0'
        nexep = 0
      endif
c
c we are done with the model file
      close (iof)
c
ccccccccccccccccccccc mesh file reading cccccccccccccccccccccccccccccccc
c
      if (mshtyp(1:4) .ne. 'PW2D') call filerr(
     *  ' Mesh type not supported', iof)
      open (iof, file=mshfil, status='old', iostat=lerr)
      if (lerr .ne. 0) then
        write(*,*) ' Error opening mesh file'
        stop
      end if
c      
c read in stuff
      read (iof,'(a)', end=198, err=199) string
      read (iof,*, end=188, err=189) lidx,nodey,nodez,nrfix,lfre,nexec
c
c screen input for errors:      
      if (lidx .ne. 0) call filerr(' Mesh file not OCCAM file', iof)
      if (nodey .gt. ipy) call filerr(' NODEY exceeds dimensions', iof)
      if (nrfix .ge. 1) call filerr('Too many fixed resistivities',iof)
c test size of nodez
      if (nodez+10 .gt. ipz) call filerr('NODEZ exceeds dimensions',iof)      
c input values for fixed resistivities, if any
      if (nrfix .ge. 1) then 
        read (iof,*, end=188, err=189) (y(i), i = 2,nrfix+1)
      end if
c input frequencies, if any (these are ignored)
      if (lfre .ge. 1) then
        read (iof,*, end=188, err=189) (dummy, i=1,lfre)
      end if
c input the element widths and heights
      read (iof,*, end=188, err=189) (dly(i), i = 1,nodey-1)
      read (iof,*, end=188, err=189) (dlz(i), i = 1,nodez-1)
c input site information, if any (these are ignored)      
      read (iof,*, end=188, err=189) nsites, (dummy, i = 1,nsites)
c input the resistivity codes
      do 25 i = 1, nodez-1
        do 25 l = 1,4
25        read (iof,'(270a1)',end=188,err=189) (apt(i,l,j), j=1,nodey-1)
      
c We are done with the mesh file
      close (iof)
c
cccccccccccccccccccc statics file reading cccccccccccccccccccccccccccccc
c
      if (ssfile(1:4) .eq. 'none' .or. ssfile(1:4) .eq. 'NONE') then
        iscon = 0
        nsb = 0
      else
        open (iof, file=ssfile, status='old', iostat=lerr)
        if (lerr .ne. 0) then
          write(*,*) ' Error opening static shift file'
          stop
        end if
c Read the stuff in it.
        read (iof,'(18x,a)', end=208, err=209) string
        if (string(1:17) .ne. 'OCCAM2MTSHIFT_1.0') call filerr(
     *    ' Static shift file not supported', iof)
        read (iof,'(18x,a)', end=208, err=209) string
        read (iof,'(18x,a)', end=208, err=209) string
        read (iof,'(18x,a)', end=208, err=209) string
        iscon = idcode(string, iof)
        read (iof,'(18x,a)', end=208, err=209) string
        sserr = rdcode(string, iof)
        read (iof,'(18x,a)', end=208, err=209) string
        nsb = idcode(string, iof)
        read (iof,'(a)', end=208, err=209) string
        do 30 i = 1,nsb
30        read (iof,*,end=208,err=209) isx1(i),isx3(i),shift(i),isfx(i)
        close (iof)
      end if
c
ccccccccccccccc decomposition parameter reading cccccccccccccccccccccccccccccc
c
      if (dpfile(1:4) .eq. 'none' .or. dpfile(1:4) .eq. 'NONE') then
        idcon = 0
        ndcp = 0
        nstat = 0
        theta = 0
      else
c open the decompostion parameter file
        open (iof, file=dpfile, status='old', iostat=lerr)
        if (lerr .ne. 0) then
          write(*,*) ' Error opening decomposition file'
          stop
        end if
c Read the stuff in it.
        read (iof,'(18x,a)', end=208, err=211) string
        if (string(1:17) .ne. 'OCCAM2MTDCOMP_1.0') call filerr(
     *    ' decompostion parameter file not supported', iof)
        read (iof,'(18x,a)', end=208, err=211) string
        read (iof,'(18x,a)', end=208, err=211) string
        read (iof,'(18x,a)', end=208, err=211) string
        idcon = idcode(string, iof)
        read (iof,'(18x,a)', end=208, err=211) string
        dperr = rdcode(string, iof)
        read (iof,'(18x,a)', end=208, err=211) string
        ndcp = idcode(string, iof)
        read (iof,'(18x,a)', end=208, err=211) string
        nstat = idcode(string, iof)
        read (iof,'(a)', end=208, err=211) string
        do 35 i = 1,nstat
         do 35 j=1,4
          read (iof,*,end=208,err=211) idx1(i,j),idx3(i,j),
     +           dcomp(i,j),idfx(i,j)
 35       continue
        read (iof,'(a)', end=208, err=211) string
        read (iof,*,end=208,err=211) theta,itfx
        close (iof)
      end if
c
cccccccccccccccccccc prejudice file reading cccccccccccccccccccccccccccc
c
      if (prfile(1:4) .ne. 'none' .and. prfile(1:4) .ne. 'NONE') then
c disallow model prejudice, ie no preferred model
        print *, 'FATAL ERROR: model prejudice disallowed, set to NONE'
        stop
      endif
c
cccccccccccccccc set up mesh and penalty matrix info ccccccccccccccccccc
c
c npt() runs from 0 (0) to 35 (Z), '?' is flagged as -99, to be overwritten 
c from the parameter array later.
      do 50 j = 1,nodey-1
        do 50 l = 1,4
          do 50 i = 1,nodez-1
            npt(i,l,j) = ichar(apt(i,l,j)) - 48
            if (npt(i,l,j) .eq. 15) npt(i,l,j) = -99
            if (npt(i,l,j) .eq. 42) npt(i,l,j) = -1
            if (npt(i,l,j) .gt. 9) npt(i,l,j) = npt(i,l,j) - 7
50      continue
c
c Set up the free parameter part of npt() and also laprm().
c The following block of code finds the outline of every parameter brick,
c and if any part of it is free, adds it to npt() and laprm().
c This block of code also computes the widths and thickness of the bricks,
c which will be needed later during the computation of the penalty matrix.
c
c initialize the number of parameters and the top edge of bricks
      nprm = 0
      inz1 = 1
c for every layer in the reg. mesh
      do 80 i = 1,nlay
c find the bottom edge of bricks and initialize the right edge of first brick
        inz2 = inz1 + irz(i) - 1
        iny1 = 1
c for every brick in that layer 
        do 70 j = 1,nrcol(i)
c set irindx() assuming that this brick is fixed (will be tested later)
          irindx(i,j) = 0
c find the right edge of brick
          iny2 = iny1 + abs(iry(i,j)) - 1
c test to see if the brick is free 
          iffree = .false.
          do 52 ii = inz1,inz2
             do 52 jj = iny1, iny2
                do 52 l = 1,4
52                 if (apt(ii,l,jj) .eq. '?') iffree = .true.
          if (iffree) then
c it is: increment the parameter count and set a new element of laprm
            nprm = nprm + 1
            laprm(nprm) = nprm + nrfix 
c set irindx() to point to the new parameter
            irindx(i,j) = nprm
c find the thickness of the brick
            thick(nprm) = 0.0
            do 55 ii = inz1, inz2
55             thick(nprm) = thick(nprm) + dlz(ii)
c find the width of the brick
            width(nprm) = 0.0
            do 57 jj = iny1, iny2
57             width(nprm) = width(nprm) + dly(jj)
c over the entire brick, including sub-triangles,
c test to see if triangular element if free and set npt() if it is
            do 60 ii = inz1,inz2
              do 60 jj = iny1, iny2
                do 60 l = 1,4
                  if (apt(ii,l,jj) .eq. '?') then
                    npt(ii,l,jj) = nprm + nrfix 
                  end if
60            continue
          end if
c increment the left edge of brick
          iny1 = iny2 + 1
70        continue
c increment the top edge of bricks
        inz1 = inz2 + 1
80      continue
c
c copy /blki/nprm into /rgrid/nbrick to give my routines the number of parameters
c which are actually resistivity bricks (c.f. static shifts)
      nbrick = nprm
c
c Now, the bricks on the edges of the mesh and the bottom of the mesh will have
c widths and thicknesses that are too large to use in regularization penalty.  Set
c them equal to their inside neighbours.  The indexing in this code is the same as
c above.
      do 85 i = 1,nlay
        do 85 j = 1, nrcol(i)
          ii = irindx(i,j)
          if (ii .gt. 0) then
            if (j .eq. 1) width(ii) = width(ii+1)
            if (j .eq. nrcol(i)) width(ii) = width(ii-1)
            if (i .eq. nlay) thick(ii) = thick(ii-nrcol(i))
          end if
85    continue
c      write(*,*) 'irindx'
c      do 87 i=1,nlay
c         write(*,'(90i2)') (irindx(i,j),j=1, nrcol(i))
c 87   continue
c 
c~~~~~~~~~~~~~~~~~~~ now assign small blocks to a larger group~~~~~~~~~~
c
c model parameters for inversion consist of resistivities of a limited number
c of blocks and the boundary depths between them
c
c first get depths to top of each layer
      depth(1) = 0.0
      do i=1,nlay
         depth(i+1) = depth(i)+thick(i*nrcol(i))
      enddo
c make sure bottom depth (at infinity) is set much lower than 2nd last
      depth(nlay+1)=3*depth(nlay)
      llay = nlay
      lcol = nrcol(1)
c get depths to the seafloor (needed later in trnslt)
      do j=1,lcol
         iseadp(j)=1
         do i=1,nlay
            if (irindx(i,j) .eq. 0) iseadp(j)=i+1
         enddo
         seadep(j)=depth(iseadp(j))
      enddo
      write(*,*) 'seadep ',seadep(1)
      write(*,*) 'iseadp ', (iseadp(j),j=1,lcol)
c
      do i=1,nbig
         kblock(i)=0
      enddo
c find # of blocks in each unit (kblock) and identities of blocks in each unit (iblock)
      do i=1,nlay
         do j=1,lcol
            l=irindx(i,j)
            if (l .ne. 0) then
c if it's a free block, check to see which large unit
               jj=0
               do ii=1,nbig
                  if (pm(l) .eq. pminv(ii)) then
                     jj=ii
                     kblock(jj) = kblock(jj)+1
                  endif
               enddo
c some block MUST be assigned to each larger unit. If not, stop
               if (jj .eq. 0) then
                 write(*,*) 'FATAL ERROR:row',i,' column',j, ' pm',pm(l)
                 stop
               endif
               iblock(jj,kblock(jj)) = l
               ijind(i,j) = jj
            else
               ijind(i,j) = 0
            endif
         enddo
      enddo
c write out unit indices
      write(*,*) 'there are', nbig, ' large units'
      if (nbig .gt. 10) then
         write(*,*) 'nbig must be .le. 11'
         stop
      endif
      write(*,*) 'index of each small block'
      do i=1,nlay
         write(*,'(80i1)') (ijind(i,j), j=1,lcol)
      enddo
c write out which small blocks belong to each unit
      do i=1,nbig
         write(*,*) kblock(i), ' blocks in unit',i
         if (kblock(i) .le. 5) then
            write(*,*) 'warning: only',kblock(i),' blocks in param',i
            write(*,*) 'this may make the inversion unstable'
         endif
c        write(*,*) 'block numbers'
c        write(*,*) (iblock(i,ii), ii=1,kblock(i))
      enddo
c
c find depth index of bottom of each layer, put in idepth
      do j=1,lcol
         do l=1,nbig-1
            idepth(l,j) = 0
            do i=1,nlay
               if(ijind(i,j) .le. l) idepth(l,j)=i
            enddo
            idepth(l,j)=idepth(l,j)+1
         enddo
         do l=2,nbig-1
            if (idepth(l,j) .lt. idepth(l-1,j)) then
               write(*,*) 'FATAL ERROR: upper layer below lower layer'
               write(*,*) 'problem found in column',j
               stop
            endif
         enddo
      enddo
c
      do l=1,nbig-1
         write(*,*) 'depth indices to bottom of unit',l
         write(*,*) (idepth(l,j),j=1,lcol)
      enddo
c put depths into the model
      npinv = nbig
      do l=1,nbig-1
         do j=1,lcol
            npinv = npinv+1
c           pminv(npinv) = depth(idepth(l,j))
c use log depth, rather than depth (take care of log(0) values)
            if (idepth(l,j) .eq. 1) then
               pminv(npinv) = alog(depth(2)) -1
            else
               pminv(npinv) = alog(depth(idepth(l,j)))
            endif
         enddo
      enddo
c
cccccccccccccccccccc set up receiver locations ccccccccccccccccccccccccc
c
c first find the position of the right edge of the left terminating layer: 
      dummy = 0.0
      do 95 i = 1, abs(iry(1,1))
95         dummy = dummy + dly(i)
c now find cumulative positions of all nodes (borrowing an array 
c used for similar thing in PW2DI), zero out iconb() 
      yy(1) = boffs - dummy
      iconb(1) = 0
      do 100 i = 1,nodey-1
        iconb(i+1) = 0
100        yy(i+1) = yy(i) + dly(i)
c find the node locations for surface conductivity boundaries
      l = 1
      do 103 i = 1, nrcol(1)
        l = l + iry(1,i)
        iconb(l) = 1
103      continue
c now find the nodes closest to the station locations, avoiding conductivity
c boundaries
      do 110 i = 1, nrc
        do 105 j = 2,nodey
          if (yy(j) .ge. sitloc(i)) then
            if (yy(j)-sitloc(i) .le. sitloc(i)-yy(j-1)) then
              nrl(i) = j
              if (iconb(j) .eq. 1) nrl(i) = j-1
            else
              nrl(i) = j-1
              if (iconb(j-1) .eq. 1) nrl(i) = j
            end if
            goto 110
          end if
105        continue
110      continue
      if (idebug .ge. 1) then
        write(*,*) 'station position    node number     actual position'
        do 111 i = 1, nrc
111          write(*,*) sitloc(i), nrl(i), yy(nrl(i))
      end if
c now check to see if two stations occupy the same location
      do 115 i = 1, nrc
        do 114 j = 1, nrc
          if ((nrl(i) .eq. nrl(j)) .and. (i.ne.j)) then
            call filerr(' Two stations on same node', 0)
          end if
114        continue
115      continue
c zero out the rest of the array (because they might be referenced by pw2di)
      do 120 i = nrc+1, nr
120        nrl(i) = 0
c
cccccccccccccccccccc set up static shift arrays cccccccccccccccccccccccc
c
c Examine the statics blocks, allocate new parameters and set up the
c data constriants
      nfss = 0
      tesum = 0.0
      tmsum = 0.0
      if (nsb .eq. 0) iscon = 0
      do 140 i = 1,nsb
        if (isfx(i) .ne. 0) then
c this static shift is a free parameter: add one more to the list
          nfss = nfss + 1
          if (nbrick + nfss .gt. npp) call filerr(
     *     ' No room for free statics in parameter array',0)
          isfx(i) = nbrick + nfss
c add a term to the constraint sums
          if (isx3(i) .eq. 1) then
            tesum = tesum + shift(i)
          else if (isx3(i) .eq. 5) then
            tmsum = tmsum + shift(i)
          else 
            call filerr(' Can only apply statics to resistivities',0)
          end if
        end if
140   continue
c
c Set up the statics constraint
      if (iscon.eq.0) then
c no constraint: do nothing
        continue
      else if (iscon .eq. 1) then
c constraint is to sum both TE and TM shifts together to whatever was the
c sum in the statics file
        nd = ndata + 1
        if (nd .gt. ndd) call filerr(  
     *     ' No room for statics constraint in data array', 0)
        dp(ndata+1,3) = 15
        d(ndata+1) = tesum + tmsum
        sd(ndata+1) = sserr
      else if (iscon .eq. 2) then
c constraint is to sum both TE and TM shifts separately to whatever was the
c sum in the statics file
        nd = ndata + 2
        if (nd .gt. ndd) call filerr( 
     *    ' No room for statics constraint in data array',0)
        dp(ndata+1,3) = 16
        dp(ndata+2,3) = 17
        d(ndata+1) = tesum
        d(ndata+2) = tmsum
        sd(ndata+1) = sserr
        sd(ndata+2) = sserr
      else
        call filerr (
     *   ' Statics constraints type greater than 2 not supported', 0)
      end if
c
      np = nbrick + nfss
      if (nfss .ne. 0) go to 999
c
cccccccccccccccccccc set up decomposition parameter info ccccccccccccccccccc
c
c Examine the decomposition blocks, allocate new parameters and set up the
c data constraints
      nfdp = 0
      xymult = 0.0
      yxmult = 0.0
      if (ndcp .eq. 0) idcon = 0
      do 240 i = 1,nstat
       do 240 j=1,4
        if (idfx(i,j) .ne. 0) then
c this decompostion parameter is free: add one more to the list
          nfdp = nfdp + 1
          if (nbrick + nfdp .gt. npp) call filerr(
     *     ' No room for decomposition parameter',0)
          idfx(i,j) = nbrick + nfdp
c add a term to the constraint sums
          if(j.eq.2) xymult = xymult + dcomp(i,j)
          if(j.eq.3) yxmult = yxmult + dcomp(i,j)
        end if
240   continue
c
c Set up the decomposition constraint
      if (idcon.eq.0) then
c no constraint: do nothing
        continue
      else if (idcon .eq. 1) then
c constraint is to sum 0.1* TE and TM parameters together
c to whatever was the sum (for off-diagonal components)
c in the decomposition file
        nd = ndata + 1
        if (nd .gt. ndd) call filerr(
     *   ' No room for decomposition constraint in data array', 0)
        dp(ndata+1,3) = 15
        d(ndata+1) = xymult+yxmult
       write(*,*) 'last datum=', d(ndata+1)
        sd(ndata+1) = dperr
      else
        call filerr (
     *   ' decomp constraint type greater than 1 not supported', 0)
      end if
c if theta doesnt equal zero then all 8 data components must
c be used at each site,frequency combination
      if((itfx.ne.0.or.theta.ne.0).and. (mod(ndata,8).ne.0)) call 
     +    filerr('must use all 8 components when theta.ne.0',0)
      write(*,*) 'nbrick,nfdp,itfx=',nbrick,nfdp,itfx
      np = nbrick + nfdp + itfx
      write(*,*) npinv,' parameters at the end of inputm'
c
ccccccccccccccccccccccc clean up and leave cccccccccccccccccccccccccccc
c
c We should have read the iteration file already and set np.  Test for
c consistency with nbrick and nfss
999   if ((np .ne. nbrick+nfss) .and. (np .ne. nbrick+nfdp+itfx))
     *  call filerr (' Model file and NP do not match', 0)
c
c that's it
      if (idebug .ge. 1) then
        write(*,*) nodey, ' x ', nodez, ' FE mesh read'
        write(*,*) npinv, ' model parameters defined'
      end if
c
      return
c
188      call filerr (' Mesh file ended prematurely', iof)
189      call filerr (' Error reading mesh file', iof)
198      call filerr (' Model file ended prematurely', iof)
199      call filerr (' Error reading model file', iof)
208      call filerr (' Statics file ended prematurely', iof)
209      call filerr (' Error reading statics file', iof)
211      call filerr (' Error reading decomposition file', iof)
218      call filerr (' Prejudice file ended prematurely', iof)
219      call filerr (' Error reading prejudice file', iof)
c
      end
C-----------------------------------------------------------------------
